% A SEND+MORE=MONEY kriptaritmetikai feladvny megoldsa a
% Method mdszerrel (Method = gen_test | block_test_gen).
send(Method, SEND, MORE, MONEY):-
  List= [S,E,N,D,M,O,R,Y],
  (   Method = gen_test ->
      domain(List, 0, 9),
      alldiff(List), dif(S, 0), dif(M, 0)
  ;   alldiff(List), dif(S, 0), dif(M, 0),
      domain(List, 0, 9)
  ),
  SEND is          1000*S+100*E+10*N+D,
  MORE is          1000*M+100*O+10*R+E,
  MONEY is 10000*M+1000*O+100*N+10*E+Y,
  SEND+MORE =:= MONEY.

% domain(?L, +Min, +Max): L minden eleme Min s Max kz esik. 
domain([], _Min, _Max).
domain([X|L], Min, Max) :-
	between(Min, Max, X),
	domain(L, Min, Max).

% alldiff(L): L elemei pronknt klnbznek.
alldiff([]).
alldiff([X|Xs]) :- outof(X, Xs), alldiff(Xs).

% outof(X, L): X klnbzik L minden elemtl.
outof(_, []).
outof(X, [Y|Ys]) :- dif(X, Y), outof(X, Ys).

% between(+N, +M, ?X): X egy N s M kz es egsz (N =< M).
between(N, M, N) :- N =< M.
between(N, M, I) :- N < M, N1 is N+1, between(N1, M, I).

